#
# spec file for package snx
#
# Copyright (c) 2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
# Copyright (c) 2008, 2014 Weberhofer GmbH, Vienna, Austria
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           snx
Summary:        SUNIX Multi-I/O Board Driver
License:        GPL-2.0
Group:          System/Kernel
Version:        2.0.4.0
Release:        1.2
Url:            http://www.sunix.com.tw/
Source0:        http://www.sunix.com/en/download/driver/2015/20150613151554_snx_V%{version}.tar.gz
Source2:        preamble
#add support the card 4065A
Patch0:         snx_4065.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  kernel-syms
BuildRequires:  module-init-tools
BuildRequires:  ncurses-devel
ExclusiveArch:  %ix86 x86_64
%suse_kernel_module_package -p %_sourcedir/preamble um

%description
SUNIX Multi-I/O Board Driver

Maximum 4 boards can be installed in combination(up to 32 serial port and 2 parallel port),
support sunix multi i/o boards as list below.

The serial interfaces are available at /dev/ttySNX*

S - serial port
P - parallel port

=============
Golden series
1S:   4027T, 4027A, 4027AL, 4027D, 4027DL, 4027P
2S:   4037T, 4037A, 4037AL, 4037D, 4037U, 4037P, 4037PL
4S:   4056A, 4056A3, 4056A4, 4056AL, 4056D, 4056J, 4056U, 4056UE,
      4056P, 4056PL, 4056PM, 4055WN,
      4056DW, 4056AM, 4056LM, 4056LL, 4056JM, 4056LV, 4000A, 4000AL,
      4000P, 4000PL
8S:   4065, 4066R, 4066U, 4066UE,
      4066WM, 4066RM, 4066JM, 8000A, 8000AL
2S1P: 4079AT
2S2P: 4089AM
4S2P: 4096A

=============
Matrix series
2S:  P1002, P2002
4S:  P1004, P2004, P3004
8S:  P1008, P2008, P3008
16S: P1016

=============
SUN1999 series
1S:   5027A, 5027AL, 5027H, 5027HL, 5027P, 5027PL, 5027PH, 5027PHL
2S:   5037A, 5037H, 5037AL, 5037HL, 5037P, 5037PH, 5037PL, 5037PHL
4S:   5056A, 5056AL, 5056H, 5056HL, 5056P, 5056PL, 5056PH, 5056PHL,
      5056U, 5056UL, 5056UH, 5056UHL
8S:   5066A, 5066H, 5066AL, 5066HL, 5066U, 5066UL, 5066UH, 5066UHL
16S:    5016H
1P:   5008A
1S1P: 5069A, 5069H, 5069P, 5069PH
2S1P: 5079A, 5079H, 5079AL
4S1P: 5099A, 5099H
2S:   IPC-P2102, IPC-P2102SI
4S:   IPC-P2104, IPC-P2104SI, IPC-P3104
8S:   IPC-P2108, IPC-P2108SI, IPC-P3108
16S:  IPC-P2116

=============
Cash Drawer
CDK1037A, CDK1037P, CDK1037H, CDK1037L
CDK1056A, CDK1056P, CDK1056H, CDK1056L

=============
DIO:
DIO0802, DIO1604, DIO3204

=============
Digitus cards:
1S:   DCSER1
2S:   DCSER2
4S:   DCSER4

%package KMP
Summary:        SUNIX Multi-I/O Board Driver
Group:          System/Kernel

%description KMP
SUNIX Multi-I/O Board Driver

Maximum 4 boards can be installed in combination(up to 32 serial port and 2 parallel port),
support sunix multi i/o boards as list below.

The serial interfaces are available at /dev/ttySNX*

S - serial port
P - parallel port

=============
Golden series
1S:   4027T, 4027A, 4027AL, 4027D, 4027DL, 4027P
2S:   4037T, 4037A, 4037AL, 4037D, 4037U, 4037P, 4037PL
4S:   4056A, 4056A3, 4056A4, 4056AL, 4056D, 4056J, 4056U, 4056UE,
      4056P, 4056PL, 4056PM, 4055WN,
      4056DW, 4056AM, 4056LM, 4056LL, 4056JM, 4056LV, 4000A, 4000AL,
      4000P, 4000PL
8S:   4065, 4066R, 4066U, 4066UE,
      4066WM, 4066RM, 4066JM, 8000A, 8000AL
2S1P: 4079AT
2S2P: 4089AM
4S2P: 4096A

=============
Matrix series
2S:  P1002, P2002
4S:  P1004, P2004, P3004
8S:  P1008, P2008, P3008
16S: P1016

=============
SUN1999 series
1S:   5027A, 5027AL, 5027H, 5027HL, 5027P, 5027PL, 5027PH, 5027PHL
2S:   5037A, 5037H, 5037AL, 5037HL, 5037P, 5037PH, 5037PL, 5037PHL
4S:   5056A, 5056AL, 5056H, 5056HL, 5056P, 5056PL, 5056PH, 5056PHL,
      5056U, 5056UL, 5056UH, 5056UHL
8S:   5066A, 5066H, 5066AL, 5066HL, 5066U, 5066UL, 5066UH, 5066UHL
16S:    5016H
1P:   5008A
1S1P: 5069A, 5069H, 5069P, 5069PH
2S1P: 5079A, 5079H, 5079AL
4S1P: 5099A, 5099H
2S:   IPC-P2102, IPC-P2102SI
4S:   IPC-P2104, IPC-P2104SI, IPC-P3104
8S:   IPC-P2108, IPC-P2108SI, IPC-P3108
16S:  IPC-P2116

=============
Cash Drawer
CDK1037A, CDK1037P, CDK1037H, CDK1037L
CDK1056A, CDK1056P, CDK1056H, CDK1056L

=============
DIO:
DIO0802, DIO1604, DIO3204

=============
Digitus cards:
1S:   DCSER1
2S:   DCSER2
4S:   DCSER4

%prep
%setup -q -n %{name}_V%{version}
%patch0 -p1
set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
export EXTRA_CFLAGS='-DVERSION=\"%version\"'
for flavor in %flavors_to_build; do
  rm -rf obj/$flavor
  cp -r source/driver obj/$flavor
  pushd obj/$flavor
  make -C "%{kernel_source $flavor}" \
	M=$PWD \
	KERNEL_SOURCE_DIR="%{kernel_source $flavor}" %{?_smp_mflags}
  popd
done

#snxdump must not be built on OSB, because it's not licensed under the GPL!

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates

for flavor in %flavors_to_build; do
  make -C "%{kernel_source $flavor}" modules_install M="$PWD/obj/$flavor"
done

%clean
rm -rf %{buildroot}

%changelog
* Tue Jun 16 2015 jweberhofer@weberhofer.at
- Updated to version V2.0.4.0
  * Support kernel up to 3.19.x
* Fri Jun 13 2014 jweberhofer@weberhofer.at
- Replace usage of interruptible_sleep_on function as it can still lead to a
  deadlock and use the race-free wait_event_interruptible function instead.
  This allowes compilation with kernel 3.15+, too.
* Fri Jan 10 2014 jweberhofer@weberhofer.at
- Updated to version V2.0.3.0
  * Support kernel up to 3.11.x
* Thu Feb  7 2013 jweberhofer@weberhofer.at
- Repackaged manually, removed temporary build files from
  sources
* Thu Feb  7 2013 jweberhofer@weberhofer.at
- Updated to V2.0.2.0
  * Support kernel up to 3.6.10
  * Add requirement package information in README file
* Thu May 10 2012 jweberhofer@weberhofer.at
- Added a patch to compile on Kernel 3.4.0
* Tue May  8 2012 jweberhofer@weberhofer.at
- Updated to V2.0.1.0
* Wed Jan 25 2012 jweberhofer@weberhofer.at
- Fixed spec to build/install flavors correctly
* Mon Jan 23 2012 jweberhofer@weberhofer.at
- Upgraded to version 2.0.0.0
* Mon Nov 14 2011 jweberhofer@weberhofer.at
- Don't build the SNX-tools, because those are not licensed under
  the GPL.
* Mon Aug  8 2011 lars@linux-schulserver.de
- Upgraded to version 1.3.3.0
- support 4065 card (snx_4065.patch)
- adapt to standard SUSE kmp builds
* Wed Mar 23 2011 opendevel@weberhofer.at
- Upgraded to version 1.3.2.0
* Mon Dec  7 2009 opendevel@weberhofer.at
- Upgraded to version 1.3.1.0
- Inserted depmod
* Mon Apr  6 2009 opendevel@weberhofer.at
- Upgraded to version 1.2.1.0
- IMPORTANT NOTE: the sources contain tools (snxterm and snxdump)
- which are copyrighted by sunix. Therefore the tools are not built under
- the openSUSE build-service
* Sat Apr  4 2009 opendevel@weberhofer.at
- Initial release of driver in OSS
